#include <stdio.h>
#include <math.h>

double funct_A(const double x)
{
   return 2*x*x*x-4*x+1;
}

double get_delta_root(double (*funct)(const double), 
		      double lb, 
		      double rb,
		      const double delta)
{
   double m=(lb+rb)/2;

   double f_lb=funct(lb),
	  f_m=funct(m);

   while (fabs(f_m)>=delta) {
       if (f_lb*f_m<0) {
	 rb=m;
       } else {
	 lb=m;
         f_lb=f_m;	 
       }

       m=(lb+rb)/2;
       f_m=funct(m);
   }

   return m;
}

int main(int argc, char *argv[])
{
   double delta=1.0;

   for (unsigned int i=0; i<6; i++) {
     double root=get_delta_root(funct_A, 0.0, 1.0, delta);

     printf("%f is a (%.0e)-root for f(x)=2*x^3-4*x+1: f(%f)=%.3e\n", 
  		   root, delta, root, funct_A(root));
     delta = delta/10;
   }

   return 0;
}
